/*
 * Caudium - An extensible World Wide Web server
 * Copyright  2000-2001 The Caudium Group
 * Based on IMHO  Stefan Wallstrm and Bosse Lincoln.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */
/*
 * $Id: globals.h,v 1.5.6.2 2001/11/02 14:51:08 oliv3 Exp $
 */

#include "screens.h"

#define DATE_IDX      0
#define SUBJECT_IDX   1
#define FROM_IDX      2
#define SENDER_IDX    3
#define REPLAYTO_IDX  4
#define TO_IDX        5
#define CC_IDX        6
#define BCC_IDX       7
#define INREPLYTO_IDX 8
#define MESSAGEID_IDX 9

#define MB_NOSELECT 1
#define MB_NOINFERIORS 2
#define MB_IMPLICIT_FOLDER 4
#define MB_PREVIOUS_FOLDER 8
// ({ foldername, displayname, flags, separator, displayname/separator })
#define MB_FOLDERNAME_IDX 0
#define MB_DISPLAYNAME_IDX 1
#define MB_FLAGS_IDX 2
#define MB_SEPARATOR_IDX 3
#define MB_HIERARCHY_IDX 4

// infos sur les folders
#define MB_MESSAGES_IDX 0
#define MB_RECENT_IDX 1
#define MB_UNSEEN_IDX 2
#define MB_SIZE_IDX 3
#define MB_NEXTUID_IDX 4 // folder has changed: ((#msg_old != #msg_new) || (#next_uid_old != #next_uid_new))

//oliv3 FIXME this seems unused
/*
#if __VERSION__ > 0.6
#define MULTILANG(ENG,SWE) (["standard":ENG,"svenska":SWE])
#else
#define MULTILANG(ENG,SWE) ENG
#endif
*/

#ifndef VAR_INITIAL
#define VAR_INITIAL 0
#endif

#define TO_UNICODE(s) (Locale.Charset.decoder(sessobj->charset)->feed(s)->drain())
#define TO_UTF8(s) (Locale.Charset.encoder("UTF-8")->feed(s)->drain())
#define FROM_UTF8(s) (Locale.Charset.decoder("UTF-8")->feed(s)->drain())


#define FEAT_USERSETUP 0
#define FEAT_ADDRESSBOOK 1
#define FEAT_MAILBOXES 2
#define FEAT_USERMAILPATH 3
#define FEAT_ATTACHMENTS 4
#define FEAT_INBOXES 5
#define FEAT_USERADDRESS 6
#define FEAT_LDAP 7
#define FEAT_DSN 8
#define FEAT_FASTIMHO 9
#define FEAT_USEREDITSETUP 10
#define FEAT_EDITADDRESSBOOK 11
#define FEAT_USERHEADERS 12
#define FEAT_MAILNOTIFY 14
#define FEAT_SHOWHTML 15          
#define FEAT_USERLANGUAGE 16
#define FEAT_USERTRASHFOLDER 17
#define FEAT_USERSENTFOLDER 18
#define FEAT_USERSENTSAVEATTACHMENTS 19
#define FEAT_SAVEMAILCOPY 21
#define FEAT_USERBCCCOPY 22
#define FEAT_USERCANCHANGENAME 23
#define FEAT_USERSETREPLYPREFIX 24
#define FEAT_USERSETUPSHOWHIDDENHEADERS 25
#define FEAT_EXTENDEDABOOK 26
// <isdnet>
#define FEAT_FORWARD 27
// </isdnet>
#define FEAT_MAILFILTER 28
#define FEAT_EDITFILTERBOOK 29

#define FEAT_STAYINATTACHMENTS 30
#define FEAT_SHOWTEXT 31
#define FEAT_USERDRAFTSFOLDER 32
#define FEAT_ORGANIZATION 33

// extended address book
#define HEADER_EBOOK_FIELDS "x-ebook-fields" /* keep headers LOWERCASE !!! */
#define HEADER_EBOOK_SUBJECT_VALUE "IMHO Extended Addressbook"

#define SIZE_SHIFT 10
#define IMAP_MDN_FLAG "\\MDNSeen"

// rfc822 date format
#define DD_INDEX	0
#define MM_INDEX	1
#define YY_INDEX	2
#define HOURS_INDEX	3
#define MINUTES_INDEX	4
#define SECONDS_INDEX	5
#define YYYY_INDEX	6
#define TZ_INDEX	7
#define WDAY_INDEX	8
#define YDAY_INDEX	9
